// CppClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CppClient.h"
#include "CppClientDlg.h"

#include <vector>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define COPY_STR(to, from) wcsncpy(to, from, TT_STRLEN)

void UserTalking(INT32 nUserID, INT32 nSampleRate, 
                 INT32 nChannels, const short* pRawAudio, 
                 INT32 nSamples, VOID* pUserData)
{

}

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCppClientDlg dialog

CCppClientDlg::CCppClientDlg(CWnd* pParent /*=NULL*/)
: CDialog(CCppClientDlg::IDD, pParent)
, m_pTTInstance(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCppClientDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_COMBO1, m_wndInput);
    DDX_Control(pDX, IDC_COMBO2, m_wndOutput);
    DDX_Control(pDX, IDC_EDIT1, m_wndAddress);
    DDX_Control(pDX, IDC_EDIT2, m_wndHostPort);
    DDX_Control(pDX, IDC_EDIT3, m_wndSoundPort);
    DDX_Control(pDX, IDC_EDIT4, m_wndJoinChannel);
    DDX_Control(pDX, IDC_RADIO1, m_wndDSound);
    DDX_Control(pDX, IDC_RADIO2, m_wndWinmm);
    DDX_Control(pDX, IDC_BUTTON1, m_wndInitSound);
    DDX_Control(pDX, IDC_BUTTON2, m_wndCloseSound);
    DDX_Control(pDX, IDC_BUTTON3, m_wndConnect);
    DDX_Control(pDX, IDC_BUTTON4, m_wndDisconnect);
    DDX_Control(pDX, IDC_BUTTON5, m_wndJoin);
    DDX_Control(pDX, IDC_EDIT5, m_wndStatus);
    DDX_Control(pDX, IDC_LIST1, m_wndUsers);
    DDX_Control(pDX, IDC_SLIDER1, m_wndUserVol);
    DDX_Control(pDX, IDC_CHECK1, m_wndUserMute);
    DDX_Control(pDX, IDC_SLIDER2, m_wndMasterVol);
    DDX_Control(pDX, IDC_PROGRESS1, m_wndVUMeter);
    DDX_Control(pDX, IDC_SLIDER3, m_wndVoiceAct);
    DDX_Control(pDX, IDC_EDIT6, m_wndNickname);
    DDX_Control(pDX, IDC_EDIT7, m_wndSPassword);
    DDX_Control(pDX, IDC_EDIT8, m_wndCPassword);
    DDX_Control(pDX, IDC_BUTTON8, m_wndLogout);
    DDX_Control(pDX, IDC_BUTTON_LEAVE, m_wndLeave);
    DDX_Control(pDX, IDC_BUTTON7, m_wndLogin);
    DDX_Control(pDX, IDC_SLIDER4, m_wndUserGain);
    DDX_Control(pDX, IDC_SLIDER5, m_wndVoiceGain);
    DDX_Control(pDX, IDC_LIST2, m_wndFiles);
    DDX_Control(pDX, IDC_BUTTON9, m_wndDownload);
    DDX_Control(pDX, IDC_BUTTON10, m_wndUpload);
    DDX_Control(pDX, IDC_BUTTON11, m_wndDelete);
    DDX_Control(pDX, IDC_COMBO3, m_wndMixerInput);
    DDX_Control(pDX, IDC_EDIT10, m_wndUsername);
    DDX_Control(pDX, IDC_EDIT11, m_wndPassword);
    DDX_Control(pDX, IDC_LIST3, m_wndChannels);
    DDX_Control(pDX, IDC_BUTTON6, m_wndTransmit);
}

BEGIN_MESSAGE_MAP(CCppClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)

	//The WM_TEAMTALK_* message handlers
    ON_MESSAGE(WM_TEAMTALK_CON_FAILED, OnConnectFailed)
    ON_MESSAGE(WM_TEAMTALK_CON_SUCCESS, OnConnectSuccess)
    ON_MESSAGE(WM_TEAMTALK_CON_LOST, OnConnectionLost)
    ON_MESSAGE(WM_TEAMTALK_CMD_MYSELF_LOGGEDIN, OnLoggedIn)
    ON_MESSAGE(WM_TEAMTALK_CMD_MYSELF_LOGGEDOUT, OnLoggedOut)
	/*session tree */
    ON_MESSAGE(WM_TEAMTALK_CMD_CHANNEL_NEW, OnAddChannel)
    ON_MESSAGE(WM_TEAMTALK_CMD_CHANNEL_UPDATE, OnUpdateChannel)
    ON_MESSAGE(WM_TEAMTALK_CMD_CHANNEL_REMOVE, OnRemoveChannel)
    ON_MESSAGE(WM_TEAMTALK_CMD_MYSELF_JOINED, OnChannelJoined)
    ON_MESSAGE(WM_TEAMTALK_CMD_MYSELF_LEFT, OnChannelLeft)

    ON_MESSAGE(WM_TEAMTALK_CMD_USER_JOINED, OnAddUser)
    ON_MESSAGE(WM_TEAMTALK_CMD_USER_UPDATE, OnUpdateUser)
    ON_MESSAGE(WM_TEAMTALK_CMD_USER_LEFT, OnRemoveUser)

    ON_MESSAGE(WM_TEAMTALK_CMD_FILE_NEW, OnAddFile)
    ON_MESSAGE(WM_TEAMTALK_CMD_FILE_REMOVE, OnRemoveFile)
    ON_MESSAGE(WM_TEAMTALK_FILETRANSFER, OnFileTransferUpdate)

    ON_MESSAGE(WM_TEAMTALK_CMD_USER_TEXTMSG, OnTextMessage)

    ON_MESSAGE(WM_TEAMTALK_USER_TALKING, OnUserTalking)
    ON_MESSAGE(WM_TEAMTALK_USER_VIDEOFRAME, OnUserVideoFrame)

    ON_MESSAGE(WM_TEAMTALK_CON_P2P, OnPeer2PeerCon)

    ON_MESSAGE(WM_TEAMTALK_CMD_MYSELF_KICKED, OnKicked)
    ON_MESSAGE(WM_TEAMTALK_CMD_SERVER_UPDATE, OnServerUpdate)
    ON_MESSAGE(WM_TEAMTALK_CMD_ERROR, OnCommandError)

    ON_MESSAGE(WM_USERVIDEODLG_CLOSED, OnUserVideoDlg)

	ON_LBN_SELCHANGE(IDC_LIST1, OnLbnSelchangeList1)
	ON_LBN_SELCHANGE(IDC_LIST3, OnLbnSelchangeList3)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, OnNMCustomdrawSlider1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER2, OnNMCustomdrawSlider2)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER3, OnNMCustomdrawSlider3)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_LEAVE, OnBnClickedButtonLeave)
	ON_BN_CLICKED(IDC_BUTTON7, OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnBnClickedButton8)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER4, OnNMCustomdrawSlider4)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER5, OnNMCustomdrawSlider5)
	ON_BN_CLICKED(IDC_BUTTON9, OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnBnClickedButton11)
END_MESSAGE_MAP()


// CCppClientDlg message handlers

BOOL CCppClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//Init the TeamTalk client
	m_pTTInstance = TT_InitTeamTalk(m_hWnd);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//m_wndAddress.SetWindowText(_T(""));
	m_wndHostPort.SetWindowText(_T("10333"));
	m_wndSoundPort.SetWindowText(_T("10333"));

	m_wndUserVol.SetRange(SOUND_VOLUME_MIN, SOUND_VOLUME_MAX);
	m_wndMasterVol.SetRange(SOUND_VOLUME_MIN, SOUND_VOLUME_MAX);
	m_wndVoiceAct.SetRange(SOUND_VU_MIN, SOUND_VU_MAX);
	m_wndVUMeter.SetRange(SOUND_VU_MIN, SOUND_VU_MAX);
    m_wndUserGain.SetRange(SOUND_GAIN_MIN, SOUND_GAIN_MAX);
	m_wndVoiceGain.SetRange(SOUND_GAIN_MIN, SOUND_GAIN_MAX);

    m_wndMasterVol.SetPos(TT_GetSoundOutputVolume(m_pTTInstance));
	TT_EnableVoiceActivation(m_pTTInstance, TRUE);
	TT_SetVoiceActivationLevel(m_pTTInstance, /*SOUND_VU_MAX / 2*/0);
	m_wndVoiceAct.SetPos(TT_GetVoiceActivationLevel(m_pTTInstance));
    m_wndVoiceGain.SetPos(TT_GetSoundInputGainLevel(m_pTTInstance));

	//fill mixer combo boxes
    int count = TT_Mixer_GetWaveInControlCount(0);
	int nSelectedIndex = -1;
	for(int i=0;i<count;i++)
	{
		TCHAR buff[TT_STRLEN] = {0};
        TT_Mixer_GetWaveInControlName(0, i, buff);
		m_wndMixerInput.AddString(buff);
        if(TT_Mixer_GetWaveInControlSelected(0, i))
			nSelectedIndex = i;
	}
	if(nSelectedIndex>=0)
		m_wndMixerInput.SetCurSel(nSelectedIndex);

	//start timer to show the current voice level.
	SetTimer(1, 100, NULL);

	m_wndAddress.SetWindowText(_T("teamtalk.dyndns.dk"));
	m_wndJoinChannel.SetWindowText(_T("/"));
	m_wndNickname.SetWindowText(_T("testclient"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCppClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCppClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCppClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CCppClientDlg::OnOK()
{
	//CDialog::OnOK();
}

void CCppClientDlg::OnCancel()
{
	BOOL b = TT_CloseTeamTalk(m_pTTInstance);
	ASSERT(b);
	CDialog::OnCancel();
}

void CCppClientDlg::AddMsg(CString szMsg)
{
	CString s;
	m_wndStatus.GetWindowText(s);
	s += szMsg + _T("\r\n");
	m_wndStatus.SetWindowText(s);
}

void CCppClientDlg::ShowDevices(SoundSystem nSoundSys)
{
	m_wndInput.ResetContent();
	m_wndOutput.ResetContent();

	//Get input devices
    vector<SoundDevice> devs;    
	int nCount = 0;
    TT_GetSoundInputDevices(m_pTTInstance, NULL, &nCount);
    if(nCount)
    {
        devs.resize(nCount);
        TT_GetSoundInputDevices(m_pTTInstance, &devs[0], &nCount);        
    }
	
	for(int i=0;i<nCount;i++)
	{
        if(devs[i].nSoundSystem != nSoundSys)
            continue;
		int x = m_wndInput.AddString(devs[i].szDeviceName);
		m_wndInput.SetItemData(x, devs[i].nDeviceID);
	}

	m_wndInput.SetCurSel(0);

	//Get output devices
	TT_GetSoundOutputDevices(m_pTTInstance, NULL, &nCount);
    if(nCount)
    {
        devs.resize(nCount);
        TT_GetSoundOutputDevices(m_pTTInstance, &devs[0], &nCount);        
    }

	for(int i=0;i<nCount;i++)
	{
        if(devs[i].nSoundSystem != nSoundSys)
            continue;
		int x = m_wndOutput.AddString(devs[i].szDeviceName);
		m_wndOutput.SetItemData(x, devs[i].nDeviceID);
	}

	m_wndOutput.SetCurSel(0);
}

void CCppClientDlg::OnBnClickedRadio1()
{
	//DSOUND selected
	ShowDevices(SOUNDSYSTEM_DSOUND);
}

void CCppClientDlg::OnBnClickedRadio2()
{
	//WINMM selected
	ShowDevices(SOUNDSYSTEM_WINMM);
}

void CCppClientDlg::OnBnClickedButton1()
{
	//Init sound system

	if(m_wndInput.GetCount() && m_wndOutput.GetCount())
	{
		//get device IDs
		int nInputID = m_wndInput.GetItemData(m_wndInput.GetCurSel());
		int nOutputID = m_wndOutput.GetItemData(m_wndOutput.GetCurSel());

		BOOL bSuccess = FALSE;
        bSuccess = TT_InitSoundInputDevice(m_pTTInstance, nInputID);
        bSuccess &= TT_InitSoundOutputDevice(m_pTTInstance, nOutputID);

		if(!bSuccess)
        {
            TT_CloseSoundInputDevice(m_pTTInstance);
            TT_CloseSoundOutputDevice(m_pTTInstance);
			AfxMessageBox(_T("Failed to init sound"));
        }
		else
		{
			m_wndInitSound.EnableWindow(FALSE);
			m_wndCloseSound.EnableWindow(TRUE);
		}
	}
}

void CCppClientDlg::OnBnClickedButton2()
{
	m_wndInitSound.EnableWindow(TRUE);
    m_wndCloseSound.EnableWindow(FALSE);
    TT_CloseSoundInputDevice(m_pTTInstance);
    TT_CloseSoundOutputDevice(m_pTTInstance);
}

void CCppClientDlg::OnBnClickedButton3()
{
	//connect
	CString szAddress, szTcpPort, szUdpPort;
	m_wndAddress.GetWindowText(szAddress);
	m_wndHostPort.GetWindowText(szTcpPort);
	m_wndSoundPort.GetWindowText(szUdpPort);

	BOOL b = TT_Connect(m_pTTInstance, szAddress, _ttoi(szTcpPort), _ttoi(szUdpPort), 0, 0);
	
	//if b = true, wait for WM_TEAMTALK_CONNECTSUCCESS or WM_TEAMTALK_CONNECTFAILED
	if(b)
	{
		m_wndConnect.EnableWindow(FALSE);
		m_wndDisconnect.EnableWindow(TRUE);
	}
}

void CCppClientDlg::OnBnClickedButton4()
{
	//disconnect
	BOOL b = TT_Disconnect(m_pTTInstance);
	ASSERT(b);
	m_wndConnect.EnableWindow(TRUE);
	m_wndDisconnect.EnableWindow(FALSE);
	m_wndLogin.EnableWindow(FALSE);
	m_wndLogout.EnableWindow(FALSE);
	m_wndJoin.EnableWindow(FALSE);
	m_wndLeave.EnableWindow(FALSE);
	m_wndDownload.EnableWindow(FALSE);
	m_wndUpload.EnableWindow(FALSE);
	m_wndDelete.EnableWindow(FALSE);

}

void CCppClientDlg::OnBnClickedButton5()
{
	//join channel (can also have topic, max users, etc.
    ServerProperties srvprop = {0};
    TT_GetServerProperties(m_pTTInstance, &srvprop);
	CString path, passwd;
	m_wndJoinChannel.GetWindowText(path);
	m_wndCPassword.GetWindowText(passwd);
    if(TT_GetChannelIDFromPath(m_pTTInstance, path)>0)
    {
        TT_DoJoinChannelByID(m_pTTInstance, 
            TT_GetChannelIDFromPath(m_pTTInstance, path),
            passwd);
    }
    else
    {
        Channel chan = {0};
        chan.nParentID = TT_GetRootChannelID(m_pTTInstance);
        if(path.Find('/') != path.ReverseFind('/'))
        {
            MessageBox(_T("This example only supports root sub channels, not sub sub channels")
                _T("Error"));
            return;
        }
        COPY_STR(chan.szName, path);
        COPY_STR(chan.szPassword, passwd);
        chan.nMaxUsers = srvprop.nMaxUsers;
        chan.codec.nCodec = SPEEX_CODEC;
        chan.codec.speex.bStereoPlayback = FALSE;
        chan.codec.speex.bUseJitterBuffer = FALSE;
        chan.codec.speex.nBandmode = 2;
        chan.codec.speex.nMSecPerPacket = 40;
        chan.codec.speex.nQuality = 4;
        chan.uChannelType = CHANNEL_DEFAULT;
        BOOL b = TT_DoJoinChannel(m_pTTInstance, &chan);
        ASSERT(b);
    }
}

LRESULT CCppClientDlg::OnConnectFailed(WPARAM wParam, LPARAM lParam)
{
	m_wndConnect.EnableWindow(TRUE);
	m_wndDisconnect.EnableWindow(FALSE);
	return TRUE;
}

LRESULT CCppClientDlg::OnConnectSuccess(WPARAM wParam, LPARAM lParam)
{
	m_wndConnect.EnableWindow(FALSE);
	m_wndDisconnect.EnableWindow(TRUE);
	m_wndLogin.EnableWindow(TRUE);

	return TRUE;
}

LRESULT CCppClientDlg::OnConnectionLost(WPARAM wParam, LPARAM lParam)
{
	m_wndConnect.EnableWindow(TRUE);
	m_wndDisconnect.EnableWindow(FALSE);
	m_wndJoin.EnableWindow(FALSE);
	m_wndLeave.EnableWindow(FALSE);

	AfxMessageBox(_T("Connection dropped"));
	return TRUE;
}

LRESULT CCppClientDlg::OnLoggedIn(WPARAM wParam, LPARAM lParam)
{
	m_wndJoin.EnableWindow(TRUE);
	m_wndLogin.EnableWindow(FALSE);
	m_wndLogout.EnableWindow(TRUE);

    ServerProperties srvprop = {0};
    TT_GetServerProperties(m_pTTInstance, &srvprop);

	CString s;
    s.Format(_T("Joined server: %s"), srvprop.szServerName);
	AddMsg(s);

    s.Format(_T("MOTD: %s"), srvprop.szMOTD);
	AddMsg(s);

	return TRUE;
}

LRESULT CCppClientDlg::OnLoggedOut(WPARAM wParam, LPARAM lParam)
{
	AddMsg(_T("Logged out of server"));
	m_wndLogin.EnableWindow(TRUE);
	m_wndLogout.EnableWindow(FALSE);
	m_wndJoin.EnableWindow(FALSE);
	m_wndLeave.EnableWindow(FALSE);
	m_wndUsers.ResetContent();

	return TRUE;
}

LRESULT CCppClientDlg::OnKicked(WPARAM wParam, LPARAM lParam)
{
	m_wndConnect.EnableWindow(TRUE);
	m_wndDisconnect.EnableWindow(FALSE);
	m_wndJoin.EnableWindow(FALSE);

	AfxMessageBox(_T("Kicked"));

	AddMsg(_T("Kicked"));
	return TRUE;
}

LRESULT CCppClientDlg::OnServerUpdate(WPARAM wParam, LPARAM lParam)
{
    ServerProperties srvprop = {0};
    TT_GetServerProperties(m_pTTInstance, &srvprop);
	CString s;
    s.Format(_T("Updated server: %s"), srvprop.szServerName);
	AddMsg(s);

    s.Format(_T("MOTD: %s"), srvprop.szMOTD);
	AddMsg(s);

	return TRUE;
}

LRESULT CCppClientDlg::OnCommandError(WPARAM wParam, LPARAM lParam)
{
	//Check out TT3CmdErrors.html in the 'Server'-folder for additional error numbers
	TCHAR buff[TT_STRLEN] = {0};
	TT_GetErrorMessage(wParam, buff);
	CString szError;
	szError.Format(_T("Error number %d occured. Description: %s\n"), wParam, buff);
	AfxMessageBox(szError);
	return TRUE;
}

LRESULT CCppClientDlg::OnAddUser(WPARAM wParam, LPARAM lParam)
{
	User user = {0};
	BOOL b = TT_GetUser(m_pTTInstance, wParam, &user);
	ASSERT(b);

	if(b)
	{
		m_users.insert(wParam);

		CString s;
		s.Format(_T("Added user #%d nick: %s"), wParam, user.szNickname);
		AddMsg(s);
        if(m_wndChannels.GetCurSel()>=0)
        {
            int nChannelID = m_wndChannels.GetItemData(m_wndChannels.GetCurSel());
            if(lParam == nChannelID)
            {
                int i = m_wndUsers.AddString(user.szNickname);
                m_wndUsers.SetItemData(i, wParam);
            }
        }
	}

	return TRUE;
}

LRESULT CCppClientDlg::OnUpdateUser(WPARAM wParam, LPARAM lParam)
{
	User user = {0};
	BOOL b = TT_GetUser(m_pTTInstance, wParam, &user);
	ASSERT(b);

	if(b)
	{
		CString s;
		s.Format(_T("Updated user #%d nick: %s"), wParam, user.szNickname);
		AddMsg(s);

		for(int i=0;i<m_wndUsers.GetCount();i++)
			if(m_wndUsers.GetItemData(i) == wParam)
			{
				m_wndUsers.DeleteString(i);
				m_wndUsers.AddString(user.szNickname);
				break;
			}
	}

	return TRUE;
}

LRESULT CCppClientDlg::OnRemoveUser(WPARAM wParam, LPARAM lParam)
{
	CString s;
	s.Format(_T("Removed user #%d"), wParam);	//user is gone from the client so we can't get the nick
	AddMsg(s);

	m_users.erase(wParam);

	for(int i=0;i<m_wndUsers.GetCount();i++)
		if(m_wndUsers.GetItemData(i) == wParam)
		{
			m_wndUsers.DeleteString(i);
			break;
		}

	return TRUE;
}

LRESULT CCppClientDlg::OnAddChannel(WPARAM wParam, LPARAM lParam)
{
	Channel chan = {0};
	TCHAR buff[TT_STRLEN] = {0};

	BOOL b = TT_GetChannel(m_pTTInstance, wParam, &chan);
	ASSERT(b);
	if(b)
	{
		TT_GetChannelPath(m_pTTInstance, wParam, buff);
		CString s;
		s.Format(_T("Added channel #%d path: %s, topic: %s"), wParam, buff, chan.szTopic);
		AddMsg(s);
        int parents = 0;
        int nChannelID = chan.nParentID;
        while(nChannelID>0)
        {
            Channel tmp = {0};
            TT_GetChannel(m_pTTInstance, nChannelID, &tmp);
            nChannelID = tmp.nParentID;
            parents++;
        }
        s = _T("- ");
        for(int i=0;i<parents;i++)
           s = _T(" ") + s;
        s += chan.szName;

        if(chan.nParentID <= 0)
        {
            int newindex = m_wndChannels.AddString(s);
            m_wndChannels.SetItemData(newindex, chan.nChannelID);
        }
        else
        {
            for(int i=0;i<m_wndChannels.GetCount();i++)
            {
                if(m_wndChannels.GetItemData(i) == chan.nParentID)
                {
                    int newindex = m_wndChannels.InsertString(i+1, s);
                    m_wndChannels.SetItemData(newindex, chan.nChannelID);
                    break;
                }
            }
        }
	}

	return TRUE;
}

LRESULT CCppClientDlg::OnUpdateChannel(WPARAM wParam, LPARAM lParam)
{
	Channel chan = {0};
	TCHAR buff[TT_STRLEN] = {0};

	BOOL b = TT_GetChannel(m_pTTInstance, wParam, &chan);
	ASSERT(b);
	if(b)
	{
		TT_GetChannelPath(m_pTTInstance, wParam, buff);
		CString s;
		s.Format(_T("Updated channel #%d name: %s, topic: %s"), wParam, buff, chan.szTopic);
		AddMsg(s);
	}
	return TRUE;
}

LRESULT CCppClientDlg::OnRemoveChannel(WPARAM wParam, LPARAM lParam)
{
	CString s;
	s.Format(_T("Removed channel #%d")); //channel doesn't exist anymore so we can't extract it.
	AddMsg(s);

    for(int i=0;i<m_wndChannels.GetCount();i++)
        if(m_wndChannels.GetItemData(i) == wParam)
        {
            m_wndChannels.DeleteString(i);
            break;
        }


	return TRUE;
}

LRESULT CCppClientDlg::OnChannelJoined(WPARAM wParam, LPARAM lParam)
{
	m_wndLeave.EnableWindow(TRUE);

	Channel chan = {0};
	TCHAR buff[TT_STRLEN] = {0};

	BOOL b = TT_GetChannel(m_pTTInstance, wParam, &chan);
	ASSERT(b);
	if(b)
	{
		TT_GetChannelPath(m_pTTInstance, wParam, buff);
		CString s;
		s.Format(_T("Joined channel #%d name: %s, topic: %s"), wParam, buff, chan.szTopic);
		AddMsg(s);

		m_wndUsers.ResetContent();
		m_wndFiles.ResetContent();

		m_wndDownload.EnableWindow(TRUE);
		m_wndUpload.EnableWindow(TRUE);
		m_wndDelete.EnableWindow(TRUE);

		//add the users in the channel to listbox
		std::set<int>::const_iterator ite = m_users.begin();
		User user = {0};
		while(ite != m_users.end())
		{
			if(TT_GetUser(m_pTTInstance, *ite, &user) && user.nChannelID == wParam)
			{
				int i = m_wndUsers.AddString(user.szNickname);
				m_wndUsers.SetItemData(i, user.nUserID);
			}
			ite++;
		}
	}
	return TRUE;
}

LRESULT CCppClientDlg::OnChannelLeft(WPARAM wParam, LPARAM lParam)
{
	m_wndLeave.EnableWindow(FALSE);
	m_wndDownload.EnableWindow(FALSE);
	m_wndUpload.EnableWindow(FALSE);
	m_wndDelete.EnableWindow(FALSE);

	Channel chan = {0};
	TCHAR buff[TT_STRLEN] = {0};

	BOOL b = TT_GetChannel(m_pTTInstance, wParam, &chan);
	//ASSERT(b); //since the TT protocol is async and PostMessage is used
	//you cannot be sure that the channel still exists
	if(b)
	{
		TT_GetChannelPath(m_pTTInstance, wParam, buff);
		CString s;
		s.Format(_T("Left channel #%d name: %s"), wParam, buff);
		AddMsg(s);

		m_wndUsers.ResetContent();
		m_wndFiles.ResetContent();
	}

	return TRUE;
}

LRESULT CCppClientDlg::OnAddFile(WPARAM wParam, LPARAM lParam)
{
    if(m_wndChannels.GetCurSel()<0)
        return TRUE;

    int nChannelID = m_wndChannels.GetItemData(m_wndChannels.GetCurSel());
	FileInfo fileinfo = {0};
	if(lParam == nChannelID && 
        TT_GetChannelFileInfo(m_pTTInstance, 
        nChannelID, wParam, &fileinfo))
	{
		int index = m_wndFiles.AddString(fileinfo.szFileName);
		m_wndFiles.SetItemData(index, wParam);
	}
	return TRUE;
}

LRESULT CCppClientDlg::OnRemoveFile(WPARAM wParam, LPARAM lParam)
{
    for(int i=0;i<m_wndFiles.GetCount();i++)
		if(m_wndFiles.GetItemData(i) == wParam)
		{
			m_wndFiles.DeleteString(i);
			break;
		}

		return TRUE;
}

LRESULT CCppClientDlg::OnFileTransferUpdate(WPARAM wParam, LPARAM lParam)
{
    FileTransfer filetransfer = {0};
    switch((FileTransferStatus)lParam)
    {
    case FILETRANSFER_STARTED :
        if(TT_GetFileTransferInfo(m_pTTInstance, wParam, &filetransfer))
        {
            CString szMsg;
            if(filetransfer.bInbound)
                szMsg = CString(_T("Started downloading ")) + filetransfer.szRemoteFileName;
            else
                szMsg = CString(_T("Started uploading ")) + filetransfer.szLocalFilePath;

            AddMsg(szMsg);
        }
        break;
    case FILETRANSFER_FINISHED :
        if(TT_GetFileTransferInfo(m_pTTInstance, wParam, &filetransfer))
        {
            CString szMsg;
            if(filetransfer.bInbound)
                szMsg = CString(_T("Finished downloading ")) + filetransfer.szRemoteFileName;
            else
                szMsg = CString(_T("Finished uploading ")) + filetransfer.szLocalFilePath;

            AddMsg(szMsg);
        }
        break;
    case FILETRANSFER_ERROR :
        {
            TCHAR buff[TT_STRLEN] = {0};
            TT_GetErrorMessage(lParam, buff);
            CString msg = _T("File transfer failed because of the following error:");
            msg += buff;
            AfxMessageBox(msg);
        }
        break;
    }
	return TRUE;
}

LRESULT CCppClientDlg::OnTextMessage(WPARAM wParam, LPARAM lParam)
{
	//wParam = userid, lParam = msg id
	User user = {0};
	BOOL b = TT_GetUser(m_pTTInstance, wParam, &user);
	ASSERT(b);
	if(b)
	{
        TextMessage msg;
		b = TT_GetTextMessage(m_pTTInstance, wParam, TRUE, &msg);
		if(b)
		{
			CString s;
            switch(msg.nMsgType)
            {
            case MSGTYPE_USER :
                s.Format(_T("Message from %s, content: %s"), user.szNickname, 
                    msg.szMessage);
                break;
            case MSGTYPE_CHANNEL :
                s.Format(_T("Message to channel from %d, content: %s"),
                    msg.nFromUserID, msg.szMessage);
                break;
            }
			AddMsg(s);
		}
	}

	return TRUE;
}

LRESULT CCppClientDlg::OnUserTalking(WPARAM wParam, LPARAM lParam)
{
    if(lParam)
        TRACE(_T("User %d is talking\n"), wParam);
    else
        TRACE(_T("User %d is stopped talking\n"), wParam);
    return TRUE;
}

LRESULT CCppClientDlg::OnUserVideoFrame(WPARAM wParam, LPARAM lParam)
{
    videodlgs_t::iterator ite = m_videodlgs.find(wParam);
    if(ite == m_videodlgs.end())
    {
        CUserVideoDlg* dlg = new CUserVideoDlg(m_pTTInstance, wParam, this);
        dlg->Create(CUserVideoDlg::IDD, this);
        dlg->ShowWindow(SW_SHOW);
        m_videodlgs[wParam] = dlg;
    }
    else
    {
        ite->second->Invalidate();
    }
    return TRUE;
}

LRESULT CCppClientDlg::OnPeer2PeerCon(WPARAM wParam, LPARAM lParam)
{
	return TRUE;
}

LRESULT CCppClientDlg::OnUserVideoDlg(WPARAM wParam, LPARAM lParam)
{
    videodlgs_t::iterator ite = m_videodlgs.find(wParam);
    if(ite != m_videodlgs.end())
    {
        ite->second->DestroyWindow();
        delete ite->second;
        m_videodlgs.erase(ite);
    }

	return TRUE;
}

void CCppClientDlg::OnLbnSelchangeList1()
{
	int nUserID = m_wndUsers.GetItemData(m_wndUsers.GetCurSel());
	if(nUserID)
	{
		m_wndUserVol.SetPos(TT_GetUserVolume(m_pTTInstance, nUserID));
        User user = {0};
        TT_GetUser(m_pTTInstance, nUserID, &user);
        m_wndUserMute.SetCheck((bool)(user.uUserState & USERSTATE_MUTE));
		m_wndUserGain.SetPos(TT_GetUserGainLevel(m_pTTInstance, nUserID));
	}
}

void CCppClientDlg::OnBnClickedCheck1()
{
	int nUserID = m_wndUsers.GetItemData(m_wndUsers.GetCurSel());
	if(nUserID)
		TT_SetUserMute(m_pTTInstance, nUserID, m_wndUserMute.GetCheck()? TRUE : FALSE);
}

void CCppClientDlg::OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	*pResult = 0;
	int nUserID = m_wndUsers.GetItemData(m_wndUsers.GetCurSel());
	if(nUserID)
		TT_SetUserVolume(m_pTTInstance, nUserID, m_wndUserVol.GetPos());
}

void CCppClientDlg::OnNMCustomdrawSlider2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	*pResult = 0;

    TT_SetSoundOutputVolume(m_pTTInstance, m_wndMasterVol.GetPos());
}

void CCppClientDlg::OnNMCustomdrawSlider3(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	*pResult = 0;
	TT_SetVoiceActivationLevel(m_pTTInstance, m_wndVoiceAct.GetPos());
}

void CCppClientDlg::OnBnClickedButton6()
{
    TT_EnableTransmission(m_pTTInstance, TRANSMIT_AUDIO, m_wndTransmit.GetCheck() == BST_CHECKED);
}

void CCppClientDlg::OnTimer(UINT_PTR nIDEvent)
{
	CDialog::OnTimer(nIDEvent);

    m_wndVUMeter.SetPos(TT_GetSoundInputLevel(m_pTTInstance));
}

void CCppClientDlg::OnBnClickedButtonLeave()
{
	TT_DoLeaveChannel(m_pTTInstance);
}

void CCppClientDlg::OnBnClickedButton7()
{
	CString nick;
	CString srvpasswd;
    CString username, passwd;
	m_wndNickname.GetWindowText(nick);
	m_wndSPassword.GetWindowText(srvpasswd);
    m_wndUsername.GetWindowText(username);
    m_wndPassword.GetWindowText(passwd);
    BOOL b = TT_DoLogin(m_pTTInstance, nick, srvpasswd,
        username, passwd);//assuming no password
	ASSERT(b);
}

void CCppClientDlg::OnBnClickedButton8()
{
	BOOL b = TT_DoLogout(m_pTTInstance);
	ASSERT(b);
    m_wndChannels.ResetContent();
}

void CCppClientDlg::OnCbnSelchangeCombo1()
{
	// TODO: Add your control notification handler code here
}

void CCppClientDlg::OnNMCustomdrawSlider4(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	*pResult = 0;
	int cursel = m_wndUsers.GetCurSel();
	int nUserID = m_wndUsers.GetItemData(cursel);
	if(nUserID)
		TT_SetUserGainLevel(m_pTTInstance, nUserID, m_wndUserGain.GetPos());
}

void CCppClientDlg::OnNMCustomdrawSlider5(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;
    TT_SetSoundInputGainLevel(m_pTTInstance, m_wndVoiceGain.GetPos());
}

void CCppClientDlg::OnBnClickedButton9()
{
    if(m_wndChannels.GetCurSel()<0)
        return;

    int nChannelID = m_wndChannels.GetItemData(m_wndChannels.GetCurSel());

	int index = m_wndFiles.GetCurSel();
	if(index != LB_ERR)
	{
		int fileid = m_wndFiles.GetItemData(index);
		FileInfo fileinfo = {0};
		if(TT_GetChannelFileInfo(m_pTTInstance, nChannelID, 
            fileid, &fileinfo))
		{
			TCHAR szFilters[] = _T("All Files (*.*)|*.*||");
			CFileDialog fileDlg(FALSE, NULL, fileinfo.szFileName, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, szFilters, this);
			if(fileDlg.DoModal() == IDOK)
				TT_DoRecvFile(m_pTTInstance, TT_GetMyChannelID(m_pTTInstance),
                fileid, fileDlg.GetPathName());
		}
	}
	else
		AfxMessageBox(_T("No file selected"));
}

void CCppClientDlg::OnBnClickedButton10()
{
	Channel channel = {0};
	if(TT_GetChannel(m_pTTInstance, TT_GetMyChannelID(m_pTTInstance), &channel))
	{
		//Make sure that the file is less than channel.nDiskQuota and the sum of all
		//files already in the channel.

		CString filetypes = _T("All files (*.*)|*.*|");
		CFileDialog dlg(TRUE, 0,0,OFN_FILEMUSTEXIST| OFN_HIDEREADONLY,filetypes, this);
		if(dlg.DoModal() == IDOK)
		{
			TT_DoSendFile(m_pTTInstance, TT_GetMyChannelID(m_pTTInstance), 
                dlg.GetPathName());
		}
	}
}

void CCppClientDlg::OnBnClickedButton11()
{
    if(m_wndChannels.GetCurSel()<0)
        return;

    int nChannelID = m_wndChannels.GetItemData(m_wndChannels.GetCurSel());

	int index = m_wndFiles.GetCurSel();
	if(index != LB_ERR)
	{
		int fileid = m_wndFiles.GetItemData(index);
		TT_DoDeleteFile(m_pTTInstance, nChannelID, fileid);
	}
}

void CCppClientDlg::OnLbnSelchangeList3()
{
    int nChannelID = m_wndChannels.GetItemData(m_wndChannels.GetCurSel());
    TTCHAR buf[TT_STRLEN] = {0};
    TT_GetChannelPath(m_pTTInstance, nChannelID, buf);
    m_wndJoinChannel.SetWindowText(buf);
    vector<int> users;
    int count = 0;
    TT_GetChannelUsers(m_pTTInstance, nChannelID, NULL, &count);
    if(count)
    {
        users.resize(count);
        TT_GetChannelUsers(m_pTTInstance, nChannelID, &users[0], &count);
    }
    m_wndUsers.ResetContent();
    for(int i=0;i<users.size();i++)
    {
        User user = {0};
        if(TT_GetUser(m_pTTInstance, users[i], &user))
        {
            int newindex = m_wndUsers.AddString(user.szNickname);
            m_wndUsers.SetItemData(newindex, user.nUserID);
        }
    }

    m_wndFiles.ResetContent();
    vector<FileInfo> files;
    TT_GetChannelFiles(m_pTTInstance, nChannelID, NULL, &count);
    if(count)
    {
        files.resize(count);
        TT_GetChannelFiles(m_pTTInstance, nChannelID, &files[0], &count);
    }

    for(int i=0;i<count;i++)
    {
        int newindex = m_wndFiles.AddString(files[i].szFileName);
        m_wndFiles.SetItemData(newindex, files[i].nFileID);
    }
}
